Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 182996 - ST Tape Driver Bug!!
Summary: ST Tape Driver Bug!!
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: kernel
Version: 3.0
Hardware: All
OS: Linux
high
high
Target Milestone: ---
Assignee: Chip Coldwell
QA Contact: Brian Brock
URL:
Whiteboard:
: 185183 (view as bug list)
Depends On:
Blocks: RHEL3U8CanFix
TreeView+ depends on / blocked
 
Reported: 2006-02-25 01:46 UTC by ravi anand
Modified: 2018-10-19 20:55 UTC (History)
6 users (show)

Fixed In Version: RHSA-2006-0437
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2006-07-20 13:53:07 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2006:0437 normal SHIPPED_LIVE Important: Updated kernel packages for Red Hat Enterprise Linux 3 Update 8 2006-07-20 13:11:00 UTC

Description ravi anand 2006-02-25 01:46:16 UTC
Description of problem:

While Running I/O to tape devices, kernel reports "Kernel BUG at pci_dma"
when the qla2300 FC HBA calls the pci_map_sg(). Looking at the dump
it turns out that the offset being passed down in non zero, but the page
address was NULL.

Tracing back to the tape driver, one of the issue we found was that the
scatter gather memory being allocated was not being initialized to zero.

The following patch address this issue.


--- st.c.orig	2006-02-08 12:35:52.000000000 -0800
+++ st.c	2006-02-08 12:36:11.000000000 -0800
@@ -3434,6 +3434,7 @@
 		st_max_sg_segs * sizeof(unsigned int);
 	tb = kmalloc(i, priority);
 	if (tb) {
+		memset(tb, 0, i);
 		tb->sg_lengths = (unsigned int *)(&tb->sg[0] + st_max_sg_segs);
 
 		if (need_dma)


Let us know if there is any issue or concern. We would like this patch
to be rolled into the next RHEL 3.0 update, hopefully U8.

Ravi Anand
QLogic Corporation.

Version-Release number of selected component (if applicable):
RHEL 3.0 U6 on x86_64 bit system using Tape driver.

How reproducible:

Within an hour or so it happens while running I/O to tape devices.
It was seen on couple of x86_64 system.

Steps to Reproduce:
1. Load qla2300.o driver. Driver version used was 7.07.01 with tape devices  
attached on RH EL 3.0 U6 64bit system (opteron) and start running I/O
to the tape device 

  
Actual results:
 System halts with "Kernel BUG at pci_dma"

Expected results:


Additional info:

Comment 3 ravi anand 2006-03-07 23:12:44 UTC
Any update on this issue ?

Ravi 

Comment 4 Chip Coldwell 2006-03-09 19:50:55 UTC
(In reply to comment #3)
> Any update on this issue ?

I've tested it on my lab system, and although I haven't reproduced the bug
I can confirm that the patch (as expected) does no harm.  I'll submit it to
our internal kernel list for review.

Chip




Comment 5 Chip Coldwell 2006-03-14 15:17:13 UTC
(In reply to comment #3)
> Any update on this issue ?
> 
> Ravi 

This patch will go in to RHEL3 U8.  Thanks for finding/fixing this bug.

Chip



Comment 10 Ernie Petrides 2006-03-28 01:20:12 UTC
A fix for this problem has just been committed to the RHEL3 U8
patch pool this evening (in kernel version 2.4.21-40.5.EL).


Comment 12 Bob Johnson 2006-04-11 15:45:46 UTC
This issue is on Red Hat Engineering's list of planned work items 
for the upcoming Red Hat Enterprise Linux 3.8 release.  Engineering 
resources have been assigned and barring unforeseen circumstances, Red 
Hat intends to include this item in the 3.8 release.

Comment 14 Chip Coldwell 2006-04-18 19:07:52 UTC
*** Bug 185183 has been marked as a duplicate of this bug. ***

Comment 18 Red Hat Bugzilla 2006-07-20 13:53:07 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2006-0437.html



Note You need to log in before you can comment on or make changes to this bug.